package com.fp.persistence.pgeneral.score;

import javax.persistence.EmbeddedId;
import javax.persistence.Entity;
import java.sql.Timestamp;
import javax.persistence.Column;
import javax.persistence.EntityManager;
import java.io.Serializable;
import javax.persistence.Table;
import com.fp.dto.hb.HibernateBean;
import java.lang.reflect.Field;
import javax.persistence.Transient;

/**Clase que implementa la entidad de Hibernate que hace referencia a la tabla TGENESCOREFILEISSUES*/
@Entity(name="TgeneScoreFileIssues")
@Table(name="TGENESCOREFILEISSUES")
public class TgeneScoreFileIssues extends com.fp.dto.AbstractDataTransport implements Serializable,HibernateBean,Cloneable{
/**
* HashCode asociado con la Instancia
*/
@Transient
private int hashValue = 0;
/**
* Version de la Clase
*/
private static final long serialVersionUID = 1L;
/**
* Clave primaria de la Entidad TgeneScoreFileIssues
*/
@EmbeddedId
private TgeneScoreFileIssuesKey pk;
@Column(name="LINECONTENT", nullable=false)

/**
* Contenido de la linea con problemas
*/
private String linecontent;

@Column(name="USERMESSAGE", nullable=true)

/**
* Mensaje del usuario por el cual no se subio esa linea
*/
private String usermessage;

@Column(name="TECHNICALMESSAGE", nullable=true)

/**
* Mensaje tecnico de porque no se subio esa linea
*/
private String technicalmessage;

/**Contructor por defecto*/
public TgeneScoreFileIssues(){
}
/**Contructor de TgeneScoreFileIssues
@param pPk Clave Primaria del entity
@param pLinecontent Contenido de la linea con problemas
*/
public TgeneScoreFileIssues(TgeneScoreFileIssuesKey pPk,String pLinecontent){
 this();
 pk=pPk;
 linecontent=pLinecontent;
}
/**
* Metodo que entrega datos de la tabla dada la clave primaria.
* @param pEntityManager referencia de la session a obtener datos del bean.
* @param pKey Caleve primaria del bean.
* @return TgeneScoreFileIssues
*/
public static TgeneScoreFileIssues find(EntityManager pEntityManager,TgeneScoreFileIssuesKey pKey) throws Exception{
    TgeneScoreFileIssues obj = pEntityManager.find(TgeneScoreFileIssues.class,pKey);
    return obj;
}
/**Entrega la Clave primaria de TgeneScoreFileIssues
@return El objeto que referencia a la Clave primaria de TgeneScoreFileIssues
*/
public TgeneScoreFileIssuesKey getPk(){
  return pk;
}
/**Fija un nuevo valor a la Clave primaria de TgeneScoreFileIssues
@param pPk El objeto que referencia a la nueva Clave primaria de TgeneScoreFileIssues
*/
public void setPk(TgeneScoreFileIssuesKey pPk){
  pk=pPk;
}
/**Obtiene el valor de linecontent
@return valor de linecontent*/
public String getLinecontent(){
  return linecontent;
}
/**Fija el valor de linecontent
@param pLinecontent nuevo Valor de linecontent*/
public void setLinecontent(String pLinecontent){
  linecontent=pLinecontent;
}

/**Obtiene el valor de usermessage
@return valor de usermessage*/
public String getUsermessage(){
  return usermessage;
}
/**Fija el valor de usermessage
@param pUsermessage nuevo Valor de usermessage*/
public void setUsermessage(String pUsermessage){
  usermessage=pUsermessage;
}

/**Obtiene el valor de technicalmessage
@return valor de technicalmessage*/
public String getTechnicalmessage(){
  return technicalmessage;
}
/**Fija el valor de technicalmessage
@param pTechnicalmessage nuevo Valor de technicalmessage*/
public void setTechnicalmessage(String pTechnicalmessage){
  technicalmessage=pTechnicalmessage;
}

public boolean equals(Object rhs){
    if (rhs == null)return false;
    if (! (rhs instanceof TgeneScoreFileIssues))return false;
    TgeneScoreFileIssues that = (TgeneScoreFileIssues) rhs;
    if (this.getPk() == null || that.getPk() == null)
        return false;
    return (this.getPk().equals(that.getPk()));
}
/**Implementacion del metodo hashCode de la la entidad TgeneScoreFileIssues
@return el hashCode la instancia
*/
public int hashCode()    {
    if (this.hashValue == 0){
        int result = 17;
        if (this.getPk() == null){
            result = super.hashCode();
        }else{
            result = this.getPk().hashCode();
        }
        this.hashValue = result;
    }
    return this.hashValue;
}
/**Implementacion toString
*/
public String toString() {
	Field[]fs=this.getClass().getDeclaredFields();
	String data="";
	for(Field f:fs){
	 try{	
	 String name=f.getName();
   if(f.getType().getName().compareTo("java.util.Set")==0)continue;
	 if(name.compareTo("hashValue")==0||name.compareTo("serialVersionUID")==0)continue;
		data+=name+"="+f.get(this)+";";
	 }catch(Exception e){
		 continue;
	 }
		}
		if(data.compareTo("")==0){
		data=super.toString();
		}
	return data;
	}
/**Implementacion de la creacion de un bean en blanco TgeneScoreFileIssues
*/
public Object createInstance(){
 TgeneScoreFileIssues instance=new TgeneScoreFileIssues();	
 instance.setPk(new TgeneScoreFileIssuesKey());
 return instance;
}
/**Clona la entidad TgeneScoreFileIssues
@see com.fp.dto.hb.HibernateBean#cloneMe()
*/
public Object cloneMe() throws CloneNotSupportedException{
  TgeneScoreFileIssues p=(TgeneScoreFileIssues)this.clone();
  p.setPk((TgeneScoreFileIssuesKey)this.pk.cloneMe());
  return p;
}
}
